#pragma once

#include <stdbool.h>
#include <sqlite3.h>
#include <lektor/window.h>

/* The only function with a setted filename */
int module_set_function(void *mod, void *handle);

/* Below there are needed functions for a window module.
 * Names are not fixed but they follow a convention (to get a code easy
 * to read). They should not be used in lektor! They will be loaded into
 * the struct lkt_win by the module_set_function.
 */
bool module_x11_new(struct lkt_win *const win);
void module_x11_close(struct lkt_win *const win);
void module_x11_free(struct lkt_win *const win);
void module_x11_attach(struct lkt_win *const win, void *server);

bool module_x11_toggle_pause(struct lkt_win *const win);
bool module_x11_load_file(struct lkt_win *const win, const char *filepath);
bool module_x11_set_volume(struct lkt_win *const win, int vol);

bool module_x11_get_duration(struct lkt_win *const win, int *dur_sec);
bool module_x11_get_elapsed(struct lkt_win *const win, int *elapsed_sec);

bool module_x11_handle_events(struct lkt_win *const win, volatile sqlite3 *db, mpd_idle_flag *mpd_idle_events);
